program NicoDIPS;

{$R *.res}
{$R DIPS_dll.res}

uses
  Windows, Messages, ShellAPI;

const
  SpeichernStr = 'NicoDIPSsaveCommand'#0;
  WiederherStr = 'NicoDIPSrestCommand'#0;
  DLLClassName = 'TNicoDIPSform'#0;
  DLLWindwName = 'NicoDIPSform'#0;
  WartenAufDLL = 5000;
  WM_SHELLTRAY = WM_USER + 5;
  MenuIDZeigen = 1000;
  MenuIDSpeich = 1010;
  MenuIDWieder = 1020;
  MenuIDBeende = 1030;

type
  TNicoDIPSinst = function(ThreadID: DWORD): BOOL;
  TNicoDIPSrels = function: BOOL;

var
  AppZentriert: BOOL;
  NicoDIPSinst: TNicoDIPSinst;
  NicoDIPSrels: TNicoDIPSrels;
  SpeichernMID: DWORD;
  WiederherMID: DWORD;
  DLLDateiPfad: array[0..2*MAX_PATH]of Char = '.\NicoDIPS.dll';
  DLLDateiHndl: DWORD;
  AppStartPara: Char = ' ';
  BitmapHandle: DWORD;
  BitmapWeiteX: Integer = 340;
  BitmapHoeheY: Integer = 180;
  DesktopThrID: DWORD;
  DesktopWndwH: DWORD;
  TNicoDIPSapp: TWndClass = (style: CS_OWNDC or CS_VREDRAW or CS_HREDRAW or
                               CS_DBLCLKS;
                             lpszClassName: 'TNicoDIPSapp');
  NicoDIPSapp: TCreateStruct = (cy: 180;
                                cx: 340;
                                y: 100;
                                x: 100;
                                style: WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU
                                  or WS_MINIMIZEBOX or WS_CLIPCHILDREN or
                                  WS_CLIPSIBLINGS;
                                lpszName: 'Nico''s DIPS');
  NicoDIPSappH: DWORD;
  NicoDIPSappM: TMsg;
  NicoDIPSappR: DWORD;
  Beenden: TCreateStruct = (cy: 30;
                            cx: 95;
                            y: 150;
                            x: 245;
                            style: WS_VISIBLE or WS_CHILD or BS_DEFPUSHBUTTON or
                              BS_FLAT;
                            lpszName: 'Beenden';
                            lpszClass: 'BUTTON');
  BeendenHandl: DWORD;
  Speichern: TCreateStruct = (cy: 30;
                              cx: 95;
                              y: 150;
                              x: 1;
                              style: WS_VISIBLE or WS_CHILD or BS_DEFPUSHBUTTON
                                or BS_FLAT;
                              lpszName: 'Speichern';
                              lpszClass: 'BUTTON');
  SpeichernHnd: DWORD;
  Wiederher: TCreateStruct = (cy: 30;
                              cx: 151;
                              y: 150;
                              x: 95;
                              style: WS_VISIBLE or WS_CHILD or BS_DEFPUSHBUTTON
                                or BS_FLAT;
                              lpszName: 'Wiederherstellen';
                              lpszClass: 'BUTTON');
  WiederherHnd: DWORD;
  NotiIconData: TNotifyIconData = (uFlags: NIF_ICON or NIF_MESSAGE or NIF_TIP;
                                   uCallbackMessage: WM_SHELLTRAY;
                                   szTip: 'Nico''s DIPS');
  PopUpMenuHnd: DWORD;

function DLLauspacken: BOOL;
var
  hResrc: HRSRC;
  nRSize: DWORD;
  hHkDLL: THandle;
  hRLoad: HGLOBAL;
  pRLock: Pointer;
  aFName: array[0..2*MAX_PATH]of Char;
begin
  Result := False;
  hResrc := FindResource(0, 'Inject', 'NicoDIPS');
  if hResrc <> 0 then
  begin
    nRSize := SizeofResource(0, hResrc);
    if GetSystemDirectory(aFName, 2*MAX_PATH) <> 0 then
    begin
      lstrcat(aFName, '\NicoDIPS.dll');
      hHkDLL := CreateFile(aFName, GENERIC_READ, FILE_SHARE_READ, nil,
                           OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
      if hHkDLL <> INVALID_HANDLE_VALUE then
      begin
        if GetFileSize(hHkDLL, nil) = nRSize then
        begin
          lstrcpy(DLLDateiPfad, aFName);
          CloseHandle(hHkDLL);
          Result := True;
        end
        else
        begin
          CloseHandle(hHkDLL);
          hRLoad := LoadResource(0, hResrc);
          if (nRSize <> 0) and (hRLoad <> 0) then
          begin
            pRLock := LockResource(hRLoad);
            if Assigned(pRLock) then
            begin
              hHkDLL := CreateFile(aFName, GENERIC_READ or GENERIC_WRITE,
                                   FILE_SHARE_WRITE, nil, TRUNCATE_EXISTING,
                                   FILE_ATTRIBUTE_NORMAL, 0);
              if hHkDLL <> INVALID_HANDLE_VALUE then
              begin
                Result := WriteFile(hHkDLL, pRLock^, nRSize, nRSize, nil);
                CloseHandle(hHkDLL);
                if Result then lstrcpy(DLLDateiPfad, aFName);
              end;
            end;
          end;
        end;
      end
      else
      begin
        hRLoad := LoadResource(0, hResrc);
        if (nRSize <> 0) and (hRLoad <> 0) then
        begin
          pRLock := LockResource(hRLoad);
          if Assigned(pRLock) then
          begin
            hHkDLL := CreateFile(aFName, GENERIC_READ or GENERIC_WRITE,
                                 FILE_SHARE_WRITE, nil, CREATE_ALWAYS,
                                 FILE_ATTRIBUTE_NORMAL, 0);
            if (hHkDLL <> INVALID_HANDLE_VALUE) then
            begin
              Result := WriteFile(hHkDLL, pRLock^, nRSize, nRSize, nil);
              CloseHandle(hHkDLL);
              if Result then lstrcpy(DLLDateiPfad, aFName);
            end;
          end;
        end;
      end;
    end;
  end;
end;

function DLLeinladen: BOOL;
begin
  Result := False;
  DLLDateiHndl := LoadLibrary(DLLDateiPfad);
  if DLLDateiHndl <> 0 then
  begin
    NicoDIPSinst := GetProcAddress(DLLDateiHndl, 'NicoDIPSinstall');
    NicoDIPSrels := GetProcAddress(DLLDateiHndl, 'NicoDIPSrelease');
    Result := NicoDIPSinst(DesktopThrID);
    PostThreadMessage(DesktopThrID, WM_NULL, 0, 0);
  end;
  if not Result then
  begin
    if DLLDateiHndl <> 0 then FreeLibrary(DLLDateiHndl);
    NicoDIPSinst := nil;
    NicoDIPSrels := nil;
  end;
end;

function DLLentladen: BOOL;
begin
  Result := False;
  if DLLDateiHndl <> 0 then
  begin
    if NicoDIPSrels then
    begin
      PostThreadMessage(DesktopThrID, WM_NULL, 0, 0);
      if FreeLibrary(DLLDateiHndl) then
      begin
        NicoDIPSinst := nil;
        NicoDIPSrels := nil;
        Result := True;
      end;
    end;
  end;
end;

function SaveRestDesktopItems(msg: UINT): BOOL;
var
  hWindw: HWND;
  dStart: DWORD;
  dJetzt: DWORD;
begin
  Result := False;
  EnableWindow(SpeichernHnd, False);
  EnableWindow(WiederherHnd, False);
  EnableWindow(BeendenHandl, False);
  try
    if DLLeinladen then
    begin
      dStart := GetTickCount;
      repeat
        if PeekMessage(NicoDIPSappM, 0, 0, 0, PM_NOREMOVE) then
        begin
          NicoDIPSappR := DWORD(GetMessage(NicoDIPSappM, 0, 0, 0));
          if (NicoDIPSappR = 0) or (NicoDIPSappR = DWORD(-1)) then
          begin
            DLLentladen;
            ExitProcess(0);
          end;
          TranslateMessage(NicoDIPSappM);
          DispatchMessage(NicoDIPSappM);
        end;
        dJetzt := GetTickCount;
        if (dJetzt < dStart) then dStart := dJetzt;
        hWindw := FindWindow(DLLClassName, DLLWindwName);
      until (hWindw <> 0) or (dJetzt - dStart > WartenAufDLL);
      if hWindw <> 0 then
      begin
        Result := BOOL(SendMessage(hWindw, msg, 0, LPARAM(DesktopWndwH)))
      end
      else
      begin
        MessageBox(0, 'Kommunikation konnte nicht hergestellt werden!', nil, 0);
      end;
      if not DLLentladen then
      begin
        MessageBox(0, 'Deinitialisierungsfehler!', nil, 0);
      end;
    end
    else
    begin
      MessageBox(0, 'Initialisierungsfehler!', nil, 0);
    end;
  finally
    EnableWindow(SpeichernHnd, True);
    EnableWindow(WiederherHnd, True);
    EnableWindow(BeendenHandl, True);
  end;
end;

function NicoDIPSappMessage(wnd: HWND; msg: UINT; wpara: WPARAM;
                            lpara: LPARAM): LRESULT; stdcall;
var
  PntStr: TPaintStruct;
  hOwnDC: HDC;
  hCmpDC: HDC;
  CltRec: TRect;
  WndRec: TRect;
begin
  Result := Ord(True);
  case msg of
    WM_CREATE:
    begin
      BitmapHandle := LoadImage(0, 'NicoDIPS.bmp', IMAGE_BITMAP,
                                BitmapWeiteX, BitmapHoeheY, LR_LOADFROMFILE);
      PopUpMenuHnd := CreatePopupMenu;
      AppendMenu(PopUpMenuHnd, MF_STRING, MenuIDZeigen, 'Anzeigen');
      AppendMenu(PopUpMenuHnd, MF_SEPARATOR, 0, nil);
      AppendMenu(PopUpMenuHnd, MF_STRING, MenuIDSpeich, Speichern.lpszName);
      AppendMenu(PopUpMenuHnd, MF_STRING, MenuIDWieder, Wiederher.lpszName);
      AppendMenu(PopUpMenuHnd, MF_SEPARATOR, 0, nil);
      AppendMenu(PopUpMenuHnd, MF_STRING or MF_DEFAULT, MenuIDBeende,
                 Beenden.lpszName);
      Result := 0;
    end;
    WM_DESTROY:
    begin
      DeleteObject(BitmapHandle);
      DestroyMenu(PopUpMenuHnd);
      PostQuitMessage(0);
    end;
    WM_ACTIVATEAPP:
      if BOOL(wpara) and not AppZentriert then
      begin
        AppZentriert := True;
        GetWindowRect(NicoDIPSappH, WndRec);
        GetClientRect(NicoDIPSappH, CltRec);
        WndRec.Right  := BitmapWeiteX + ((WndRec.Right - WndRec.Left)
                         - (CltRec.Right - CltRec.Left));
        WndRec.Bottom := BitmapHoeheY + ((WndRec.Bottom - WndRec.Top)
                         - (CltRec.Bottom - CltRec.Top));
        SystemParametersInfo(SPI_GETWORKAREA, 0, @CltRec, 0);
        WndRec.Left := (CltRec.Right - WndRec.Right) div 2;
        WndRec.Top  := (CltRec.Bottom - WndRec.Bottom) div 2;
        MoveWindow(NicoDIPSappH, WndRec.Left, WndRec.Top,
                   WndRec.Right, WndRec.Bottom, False);
      end
      else
      begin
        Result := DefWindowProc(wnd, msg, wpara, lpara);
      end;
    WM_SIZE:
      if wpara = SIZE_MINIMIZED then
      begin
        NotiIconData.cbSize := SizeOf(NotiIconData);
        NotiIconData.Wnd := wnd;
        NotiIconData.uCallbackMessage := WM_SHELLTRAY;
        NotiIconData.hIcon := TNicoDIPSapp.hIcon;
        ShowWindow(NicoDIPSappH, SW_HIDE);
        Shell_NotifyIcon(NIM_ADD, @NotiIconData);
      end
      else
      begin
        Result := DefWindowProc(wnd, msg, wpara, lpara);
      end;
    WM_PAINT:
      if GetClientRect(NicoDIPSappH, CltRec) then
      begin
        hOwnDC := BeginPaint(NicoDIPSappH, PntStr);
        hCmpDC := CreateCompatibleDC(hOwnDC);
        SelectObject(hCmpDC, BitmapHandle);
        StretchBlt(hOwnDC, 0, 0, CltRec.Right, CltRec.Bottom,
                   hCmpDC, 0, 0, BitmapWeiteX, BitmapHoeheY, SRCCOPY);
        DeleteDC(hCmpDC);
        EndPaint(NicoDIPSappH, PntStr);
      end
      else
      begin
        Result := DefWindowProc(wnd, msg, wpara, lpara);
      end;
    WM_NCHITTEST:
    begin
      Result := DefWindowProc(wnd, msg, wpara, lpara);
      if Result = HTCLIENT then Result := HTCAPTION;
    end;
    WM_COMMAND:
      if wpara = BN_CLICKED then
      begin
        if DWORD(lpara) = BeendenHandl then
        begin
          SendMessage(NicoDIPSappH, WM_CLOSE, 0, 0);
        end
        else
        begin
          if (Cardinal(lpara) = SpeichernHnd) then
          begin
            if (DesktopThrID <> 0) and (DesktopWndwH <> 0) then
            begin
              SaveRestDesktopItems(SpeichernMID);
            end
            else
            begin
              MessageBox(0, 'Symbolliste nicht gefunden!', nil, 0);
            end;
          end
          else
          begin
            if (Cardinal(lpara) = WiederherHnd) then
            begin
              if (DesktopThrID <> 0) and (DesktopWndwH <> 0) then
              begin
                SaveRestDesktopItems(WiederherMID);
              end
              else
              begin
                MessageBox(0, 'Symbolliste nicht gefunden!', nil, 0);
              end;
            end
            else
            begin
              Result := DefWindowProc(wnd, msg, wpara, lpara);
            end;
          end;
        end;
      end
      else
      begin
        if lpara = 0 then
        begin
          case wpara of
            MenuIDSpeich: SendMessage(NicoDIPSappH, WM_COMMAND,
                                      BN_CLICKED shl 16, SpeichernHnd);
            MenuIDWieder: SendMessage(NicoDIPSappH, WM_COMMAND,
                                      BN_CLICKED shl 16, WiederherHnd);
            MenuIDZeigen:
            begin
              Shell_NotifyIcon(NIM_DELETE, @NotiIconData);
              ShowWindow(NicoDIPSappH, SW_RESTORE);
            end;
            MenuIDBeende:
            begin
              Shell_NotifyIcon(NIM_DELETE, @NotiIconData);
              SendMessage(NicoDIPSappH, WM_COMMAND, BN_CLICKED shl 16,
                          BeendenHandl);
            end;
          end;
        end
        else
        begin
          Result := DefWindowProc(wnd, msg, wpara, lpara);
        end;
      end;
    WM_SHELLTRAY:
      case lpara of
        WM_RBUTTONDOWN:
        begin
          GetCursorPos(CltRec.TopLeft);
          SetForegroundWindow(NicoDIPSappH);
          TrackPopupMenu(PopUpMenuHnd, TPM_RIGHTALIGN, CltRec.TopLeft.x,
                         CltRec.TopLeft.y, 0, NicoDIPSappH, nil);
          PostMessage(NicoDIPSappH, WM_NULL, 0, 0);
        end;
        WM_LBUTTONDBLCLK:
          SendMessage(NicoDIPSappH, WM_COMMAND, MenuIDZeigen, 0);
      end;
    else
    begin
      Result := DefWindowProc(wnd, msg, wpara, lpara);
    end;
  end;
end;

begin
  DesktopWndwH := GetTopWindow(GetTopWindow(FindWindow('Progman', nil)));
  DesktopThrID := GetWindowThreadProcessId(DesktopWndwH, nil);
  SpeichernMID := RegisterWindowMessage(SpeichernStr);
  WiederherMID := RegisterWindowMessage(WiederherStr);
  DLLauspacken;
  TNicoDIPSapp.lpfnWndProc := @NicoDIPSappMessage;
  TNicoDIPSapp.hInstance := HInstance;
  TNicoDIPSapp.hIcon := LoadIcon(HInstance, 'MAINICON');
  TNicoDIPSapp.hCursor := LoadCursor(0, Pointer(IDC_ARROW));
  TNicoDIPSapp.hbrBackground := GetStockObject(GRAY_BRUSH);
  if RegisterClass(TNicoDIPSapp) <> 0 then begin
    NicoDIPSapp.hInstance := TNicoDIPSapp.hInstance;
    NicoDIPSapp.lpszClass := TNicoDIPSapp.lpszClassName;
    NicoDIPSappH := CreateWindow(NicoDIPSapp.lpszClass, NicoDIPSapp.lpszName,
                                 NicoDIPSapp.style, NicoDIPSapp.x,
                                 NicoDIPSapp.y, NicoDIPSapp.cx, NicoDIPSapp.cy,
                                 0, 0, NicoDIPSapp.hInstance,
                                 NicoDIPSapp.lpCreateParams);
    if (NicoDIPSappH <> 0) then begin
      NicoDIPSapp.hMenu := GetSystemMenu(NicoDIPSappH, False);
      Beenden.hInstance := HInstance;
      Beenden.hwndParent := NicoDIPSappH;
      BeendenHandl := CreateWindow(Beenden.lpszClass, Beenden.lpszName,
                                   Beenden.style, Beenden.x, Beenden.y,
                                   Beenden.cx, Beenden.cy, Beenden.hwndParent,
                                   0, Beenden.hInstance,
                                   Beenden.lpCreateParams);
      Speichern.hInstance := HInstance;
      Speichern.hwndParent := NicoDIPSappH;
      SpeichernHnd := CreateWindow(Speichern.lpszClass, Speichern.lpszName,
                                   Speichern.style, Speichern.x, Speichern.y,
                                   Speichern.cx, Speichern.cy,
                                   Speichern.hwndParent, 0, Speichern.hInstance,
                                   Speichern.lpCreateParams);
      Wiederher.hInstance := HInstance;
      Wiederher.hwndParent := NicoDIPSappH;
      WiederherHnd := CreateWindow(Wiederher.lpszClass, Wiederher.lpszName,
                                   Wiederher.style, Wiederher.x,
                                   Wiederher.y, Wiederher.cx, Wiederher.cy,
                                   Wiederher.hwndParent, 0, Wiederher.hInstance,
                                   Wiederher.lpCreateParams);
      if (BeendenHandl <> 0)
      and (SpeichernHnd <> 0)
      and (WiederherHnd <> 0) then
      begin
        if (ParamCount >= 1) then
        begin
          if (Length(ParamStr(1)) >= 2) then
          begin
            AppStartPara := ParamStr(1)[2];
          end;
        end;
        case AppStartPara of
          'S', 's': SaveRestDesktopItems(SpeichernMID);
          'W', 'w': SaveRestDesktopItems(WiederherMID);
          ' '     : ;
          else
          begin
            MessageBox(0, PChar(#13#10'Kommandozeilen-Parameter:'#13#10#13#10+
                                '     /S  =  Desktopsymbole speichern'#13#10+
                                '     /W  =  Desktopsymbole speichern'#13#10),
                                'Nico''s DIPS', MB_ICONINFORMATION);
            AppStartPara := ' ';
          end;
        end;
        if (AppStartPara = ' ') then
        begin
          ShowWindow(NicoDIPSappH, SW_SHOWDEFAULT);
          UpdateWindow(NicoDIPSappH);
          repeat
          NicoDIPSappR := DWORD(GetMessage(NicoDIPSappM, 0, 0, 0));
          case NicoDIPSappR of
            0, DWORD(-1): Break;
            else
            begin
              TranslateMessage(NicoDIPSappM);
              DispatchMessage(NicoDIPSappM);
            end;
          end;
          until False;
        end;
      end;
    end;
    UnregisterClass(TNicoDIPSapp.lpszClassName, NicoDIPSapp.hInstance);
  end;
end.


